package edu.berkeley.cs160.alarmbuddy;

/* ===== AlarmOffScreen.JAVA =====
 *  Author: Jessica Fitzgerald
 *  
 *  
 *  ===================== 
 */

import android.content.Context;
import android.content.Intent;
import android.content.IntentReceiver;
import android.os.Bundle;
import android.util.Log;


/**
 * This is the receiver that is used when the alarm goes off
 * It creates an activity which will launch the ability to turn off the alarm 
 */

public class AlarmSetOff extends IntentReceiver
{
    @Override
    public void onReceiveIntent(Context context, Intent intent)
    {
        // Start up the activity that displays the alarm options
    	Bundle extras = intent.getExtras();
    	assert extras != null;
    	long alarmId = extras.getLong(MiniAppDb.KEY_ALARM_ID);
    	Intent i = new Intent(context, AlarmOffScreen.class);
    	
    	Log.println(100, "wtf", "wtf: AlarmSetOff: alarmId=" + alarmId);
    	
    	i.putExtra(MiniAppDb.KEY_ALARM_ID, alarmId);
    	i.addLaunchFlags(Intent.NEW_TASK_LAUNCH);
        context.startActivity(i);
        
    }
}
