package edu.berkeley.cs160.alarmbuddy;

/* ===== EDITALARM.JAVA =====
 *  Author: 
 *  
 *  
 *  ===================== 
 */



import org.apache.commons.httpclient.methods.GetMethod;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.Intent;
import android.content.Resources;
import android.database.Cursor;
import android.graphics.Matrix;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.ViewInflate;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.Spinner;
import android.widget.AdapterView.OnItemSelectedListener;

public class EditAlarm extends Activity {

	private EditText mTitleText, mMinuteText, mHourText;
	//private TimePicker timePicker;
	private Spinner recurrenceSpinner, toneSpinner, amPmSpinner;
	private MiniAppDb mMiniAppDb;
	
	public static final int ACTIVITY_ADD_MINI_APP = 1;

	Bundle info;
	long mRowId = -1;

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle icicle) {
		super.onCreate(icicle);
		setContentView(R.layout.editalarms);
		
		mTitleText = (EditText) findViewById(R.id.title);

		Button addMiniAppButton = (Button) findViewById(R.id.addMiniAppButton);
		
		final Activity context = this;
		
		addMiniAppButton.setOnClickListener(new View.OnClickListener() {
			/** Opens the EditAlarm screen when an alarm is selected with the EDIT intent. **/
			public void onClick(View v) {
				Intent i = new Intent(context, AddMiniApp.class);
				startSubActivity(i, EditAlarm.ACTIVITY_ADD_MINI_APP);
			}
        });		
		
		/* Register confirm button to send data back to myAlarms screen */
		
		Button confirmButton = (Button) findViewById(R.id.editAlarmConfirm);
		
		String requestedAction = getIntent().getAction() ;
		info = getIntent().getExtras(); //the bundle with all the alarm's info
		assert info != null;
		
		mRowId = info.getLong(AlarmsDbAdapter.KEY_ROWID);
		
		if (requestedAction.equals("EDIT")) {
			String title = info.getString(AlarmsDbAdapter.KEY_TITLE);
			if (title != null) {
				mTitleText.setText(title);
				
			}
		} else if (requestedAction.equals("CREATE")) {
			mTitleText.setText("New Alarm");
		}
	
		// create AddMiniApp button
		// miniapp alarmIds == Alarms' row Ids.  HACKY I KNOW :(((
		mMiniAppDb = new MiniAppDb(this, mRowId);
		mMiniAppDb.open();
		
		createMiniAppButton();
		createMiniAppList();
		/* Register confirm button to send data back to myAlarms screen */
		confirmButton.setOnClickListener(new View.OnClickListener() {

            public void onClick(View view) {
                Bundle bundle = new Bundle();
                int hours = new Integer(mHourText.getText().toString());
                int isPm = amPmSpinner.getSelectedItemPosition();
                if(isPm==0 && hours == 12) {
                	hours = 0;
                }
                hours += isPm*12;
                int totalMinutes = hours * 60 +
                				new Integer(mMinuteText.getText().toString());
                Log.println(100, "PRINTED", "totalMinutes: " + totalMinutes);
                //Log.println(100, "PRINT", "EditAlarm: mRowId="+mRowId);
                bundle.putLong(AlarmsDbAdapter.KEY_ROWID, mRowId);
                bundle.putString(AlarmsDbAdapter.KEY_TITLE, mTitleText.getText().toString());
                bundle.putInt(AlarmsDbAdapter.KEY_TIME, totalMinutes);
                bundle.putString(AlarmsDbAdapter.KEY_RECURRENCE, recurrenceSpinner.getSelectedItem().toString());
                bundle.putString(AlarmsDbAdapter.KEY_TONE, toneSpinner.getSelectedItem().toString());
                bundle.putInt(AlarmsDbAdapter.KEY_IS_TIMER, 0);
                //Log.println(100, "PRINT", "EditAlarm: mTitleText="+mTitleText.getText().toString());
                
                setResult(RESULT_OK, null, bundle);
                finish();
            }
        });
		
		/* Set up TimeField */
		mHourText = (EditText) findViewById(R.id.hourField);
		mMinuteText = (EditText) findViewById(R.id.minuteField);
		amPmSpinner = (Spinner) findViewById(R.id.amPmSpinner);

		int totalMinutes = info.getInt(AlarmsDbAdapter.KEY_TIME);

		if (totalMinutes!=0) {
			int hours = totalMinutes / 60;
			if(hours > 12) {
				hours -= 12;
			} else if(hours == 0) {
				hours = 12;
			}
			mHourText.setText(new Integer(hours).toString());
	        mMinuteText.setText(new Integer(totalMinutes%60).toString());
		} else {
			mHourText.setText("12");
	        mMinuteText.setText("00");
		}
		
		
		// set up am pm spinner
		ArrayAdapter<CharSequence> adapter = ArrayAdapter.createFromResource(
                this, R.array.am_pm, android.R.layout.simple_spinner_item);
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        amPmSpinner.setAllowWrap(true);
        amPmSpinner.setAdapter(adapter);
        amPmSpinner.setSelection((totalMinutes < 720) ? 0 : 1);
        
		// set up recurrence spinner
        recurrenceSpinner = (Spinner) findViewById(R.id.spinner1);
        adapter = ArrayAdapter.createFromResource(
                this, R.array.recurrence, android.R.layout.simple_spinner_item);
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        recurrenceSpinner.setAdapter(adapter);
        String recurrence = info.getString(AlarmsDbAdapter.KEY_RECURRENCE);
        recurrenceSpinner.setSelection(adapter.getPosition(recurrence));
        recurrenceSpinner.setOnItemSelectedListener(new OnItemSelectedListener(){
            @Override
            public void onItemSelected(AdapterView parent, View v,
                      int position, long id) {
            	if (position == 2) {
            		customRecurrenceSelected();
            	}
            }
            @Override
            public void onNothingSelected(AdapterView arg0) {
            }
     });
     //this.setContentView(recurrenceSpinner);
        
        
		// set up Tone spinner
        toneSpinner = (Spinner) findViewById(R.id.spinner2);
        adapter = ArrayAdapter.createFromResource(this, R.array.tone,
                android.R.layout.simple_spinner_item);
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        toneSpinner.setAdapter(adapter);
        String tone = info.getString(AlarmsDbAdapter.KEY_TONE);
        toneSpinner.setSelection(adapter.getPosition(tone));
        
	}
	
	public View.OnClickListener cancelButtonAction() {
		return new View.OnClickListener() {
			public void onClick(View view) {
                setResult(RESULT_CANCELED, null, null);
                finish();
            }
		};
	}
	
	private void customRecurrenceSelected() {
		ViewInflate inflate = (ViewInflate) getSystemService(Context.INFLATE_SERVICE);
	    final View view = inflate.inflate(R.layout.custom_recurrence, null, null);
	    	
		new AlertDialog.Builder(this)
        .setView(view)
		.show();
	}
	
	
	/**
	 * Setup everything necessary for the AddMiniApp button
	 */
	private void createMiniAppButton() {
		assert mRowId != -1;
		Button addMiniAppButton = (Button) findViewById(R.id.addMiniAppButton);
		
		final Activity context = this;
		
		addMiniAppButton.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				Intent i = new Intent(context, AddMiniApp.class);
				i.putExtra(MiniAppDb.KEY_ALARM_ID, mRowId);
				startSubActivity(i, EditAlarm.ACTIVITY_ADD_MINI_APP);
			}
	    });	
	}
	
	/**
	 * Setup the list of Editable MiniApps.
	 */
	private void createMiniAppList() {
		
		
		Cursor c = mMiniAppDb.fetchMiniAppCursorByAlarmId();
		c.first();
		int count = c.count();
		LinearLayout layout = (LinearLayout) findViewById(R.id.miniAppLinearLayout);
		
		// clear existing children
		layout.removeAllViews();
		final Context ctx = this;
		
		for(c.first(); c.position() < count; c.next()) {
			String name = c.getString(c.getColumnIndex(MiniAppDb.KEY_MINIAPP_NAME));
			MiniAppActivity m = MiniAppActivity.miniAppFromString(name);
			int iconAddress = m.getIconAddress();
			
			LinearLayout.LayoutParams iconParams = 
                new LinearLayout.LayoutParams(40, 40);
            iconParams.setMargins(1,1,1,1);
            
            Drawable icon = this.getResources().getDrawable(m.getIconAddress());
			ImageButton iconButton = new ImageButton(this);
			iconButton.setPreferredHeight(40);
			iconButton.setPreferredWidth(40);
			iconButton.setImageDrawable(icon);
			iconButton.setClickable(true);
			iconButton.setAdjustViewBounds(true);
			
			// scale down images
			Matrix mat = new Matrix();
			mat.preScale(.6f, .6f);
			mat.preTranslate(-8f, -10f);
			iconButton.setImageMatrix(mat);
			iconButton.setScaleType(ImageView.ScaleType.MATRIX);
			// associate an instance of the miniApp with m
			iconButton.setTag(m);
	
			// fire up a new MiniApp screen if confirm button is hit.
			iconButton.setOnClickListener(
					new View.OnClickListener() {
						public void onClick(View v) {
	        		
							/** Opens the appropriate MiniApp Creation activity **/
							MiniAppActivity m = (MiniAppActivity) v.getTag();
							Class<MiniAppActivity> maClass = m.getActivityClass();
							Intent i = new Intent(ctx, maClass);
							i.putExtra(MiniAppDb.KEY_ALARM_ID, mRowId);
					
							mMiniAppDb.updateInstance(m.getNiceName());
							startSubActivity(i, AddMiniApp.ACTIVITY_ADD_MINIAPP);
						}
					}
			);
			layout.addView(iconButton, iconParams);
		}
		
	}
	
	@Override
	protected void onActivityResult(int requestCode, int resultCode, String data, Bundle extras) {
		createMiniAppList();
	}
	
    /*progressButton.setOnClickListener(new OnClickListener() {
        public void onClick(View v) {
            new AlertDialog.Builder(AlertDialogSamples.this)
                    .setIcon(R.drawable.star_big_on)
                    .setTitle(R.string.select_dialog)
                    .setView(view)
                     .setPositiveButton(R.string.alert_dialog_hide, new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int whichButton) {
                            
                        }
                    })
                    .setNegativeButton(R.string.alert_dialog_cancel, new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int whichButton) {
                            
                        }
                    })
                   .show();
        }
    });*/
	
	
	
	
}