package edu.berkeley.cs160.alarmbuddy;

import android.app.Activity;
import android.content.Context;
import android.graphics.drawable.Drawable;

/**
 *  MiniAppActivity.java
 * 
 *  @author Mike Ross
 *  
 *  An class to encapsulate MiniApp Activities
 */


public abstract class MiniAppActivity extends Activity {
	//abstract protected MiniAppDb getInstanceDb();
	
	public static final int ACTIVITY_EDIT = 0;
	public static final int ACTIVITY_ADD = 1;
	public static final int ACTIVITY_ALARM_OFF = 2;
	public static final String KEY_ACTIVITY_TYPE = "activity_type";

	
	/**
	 * Return an instance of the MiniApp designated by the given string 
	 * @param s
	 */
	public static MiniAppActivity miniAppFromString(String s) {
		//TODO make this generalized?  Use reflection?
		
		if(s.equals(ToDoMiniAppWrapper.NICE_NAME)) {
			return new ToDoMiniAppWrapper();
		} else if(s.equals(Weather.NICE_NAME)) {
			return new Weather();
		} else if(s.equals(WeatherReal.NICE_NAME)) {
			return new WeatherReal();
		}
		return null;

	}
	
	
	/** 
	 * return the class for starting activities.
	 */
	public Class getActivityClass() {
		return getClass();
	}
	
    abstract protected String getNiceName();
    abstract protected String getIconPath();
    abstract protected int getIconAddress();
    

	/** 
	 * Delete the instance with the given instanceId
	 * @param rowId
	 * @return
	 */
	public void deleteInstance(long instanceId) {

	}
	
	
}