/**
 * A pair of classes to facilitate viewing miniapps
 */

package edu.berkeley.cs160.alarmbuddy;

import android.content.Context;
import android.graphics.Color;
import android.graphics.drawable.Drawable;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

class MiniAppAdapterView extends LinearLayout {        
        public MiniAppAdapterView(Context context, MiniAppActivity m) {
        	super(context);

        	this.setOrientation(VERTICAL);

        	// create image.
        	LinearLayout.LayoutParams iconParams = 
        		new LinearLayout.LayoutParams(50, 50);
        	iconParams.setMargins(1,1,1,1);
        	
        	ImageView iconButton = new ImageView(context);
        	int iconAddress = m.getIconAddress();
        	iconButton.setImageResource(iconAddress);
        	addView(iconButton, iconParams);
        	
        	//create name field
        	LinearLayout.LayoutParams nameParams = 
                new LinearLayout.LayoutParams(LayoutParams.WRAP_CONTENT, 14);
            nameParams.setMargins(1, 1, 1, 1);

            TextView nameControl = new TextView(context);
            nameControl.setText( m.getNiceName() );
            nameControl.setTextSize( 14f );
            nameControl.setTextColor(Color.WHITE);
            addView(nameControl, nameParams);
        }
}

class MiniAppAdapter extends BaseAdapter {

    private Context mContext;
    private MiniAppActivity[] mMiniApps;

    public MiniAppAdapter(Context context, MiniAppActivity[] miniApps) { 
        this.mContext = context;
        this.mMiniApps = miniApps;
    }

    public int getCount() {                        
        return mMiniApps.length;
    }

    public Object getItem(int position) {     
        return mMiniApps[position];
    }

    public long getItemId(int position) {  
        return position;
    }

    public View getView(int position, View convertView, ViewGroup parent) { 
        MiniAppActivity m = mMiniApps[position];
        return new MiniAppAdapterView(this.mContext, m);
    }

}
