package edu.berkeley.cs160.alarmbuddy;

/**
 * 	From Notepad Edit page.
 * 	Unchanged... yet.
 * 	-- andry jong
 */

import android.app.Activity;
import android.database.Cursor;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;

public class ToDoEdit extends Activity {

	public static final String KEY_NEW_NOTE = "new_note";
	private EditText mTitleText;
    private EditText mBodyText;
    private Long mRowId = null;
    private ToDoDbAdapter mDbHelper;
    private long mAlarmId = -1;
    private boolean mNewNote;
    
    @Override
    protected void onCreate(Bundle icicle) {
    	super.onCreate(icicle);
    	
    	// figure out what alarm is currently using the miniApp so we
        // can retrieve the appropriate data
    	Bundle extras = getIntent().getExtras();
    	assert extras != null;
    	mAlarmId = extras.getLong(MiniAppDb.KEY_ALARM_ID);
    	
        mDbHelper = new ToDoDbAdapter(this, mAlarmId);
        mDbHelper.open();
       
        setContentView(R.layout.note_edit);
       
        mTitleText = (EditText) findViewById(R.id.title);
        mBodyText = (EditText) findViewById(R.id.body);
       
        Button confirmButton = (Button) findViewById(R.id.confirm);
        
      
        
        // set the row id we're editing.
        if(icicle != null) {
        	mNewNote = icicle.getBoolean(KEY_NEW_NOTE);
        	mRowId = icicle.getLong(ToDoDbAdapter.KEY_ROWID);
        } else {
            mRowId = extras.getLong(ToDoDbAdapter.KEY_ROWID);
            mNewNote = extras.getBoolean(KEY_NEW_NOTE);
        }
       
        
        
        confirmButton.setOnClickListener(new View.OnClickListener() {

            public void onClick(View view) {
                setResult(RESULT_OK);
                finish();
            }
           
        });
    }
    
    private void populateFields() {
        if(!mNewNote) {
            Cursor note = mDbHelper.fetchNote(mRowId);
            startManagingCursor(note);
            mTitleText.setText(note.getString(
    	            note.getColumnIndex(ToDoDbAdapter.KEY_TITLE)));
            mBodyText.setText(note.getString(
                    note.getColumnIndex(ToDoDbAdapter.KEY_BODY)));
    	}
    }
    
    @Override
    protected void onFreeze(Bundle outState) {
        super.onFreeze(outState);
        outState.putBoolean(KEY_NEW_NOTE, mNewNote);
        outState.putLong(ToDoDbAdapter.KEY_ROWID, mRowId);
    }
    
    @Override
    protected void onPause() {
        super.onPause();
        saveState();
    }
    
    @Override
    protected void onResume() {
        super.onResume();
        Bundle extras = getIntent().getExtras();
        mNewNote = extras.getBoolean(KEY_NEW_NOTE);
        populateFields();
    }
    
    private void saveState() {
        String title = mTitleText.getText().toString();
        String body = mBodyText.getText().toString();

        if (mNewNote) {
            long id = mDbHelper.createNote(title, body);
            if (id > 0) {
                mRowId = id;
            }
        } else {
            mDbHelper.updateNote(mRowId, title, body);
        }
    }
}
